/******************************************************************************
 *
 * Copyright(c) 2016 - 2017 Realtek Corporation. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 ******************************************************************************/

#ifndef _HAL_FWOFFLOADH2CFORMAT_H2C_C2H_AP_H_
#define _HAL_FWOFFLOADH2CFORMAT_H2C_C2H_AP_H_
#define CMD_ID_FW_OFFLOAD_H2C  0XFF
#define CMD_ID_CHANNEL_SWITCH  0XFF
#define CMD_ID_DUMP_PHYSICAL_EFUSE  0XFF
#define CMD_ID_UPDATE_BEACON_PARSING_INFO  0XFF
#define CMD_ID_CFG_PARAMETER  0XFF
#define CMD_ID_UPDATE_DATAPACK  0XFF
#define CMD_ID_RUN_DATAPACK  0XFF
#define CMD_ID_DOWNLOAD_FLASH  0XFF
#define CMD_ID_UPDATE_PACKET  0XFF
#define CMD_ID_GENERAL_INFO  0XFF
#define CMD_ID_IQK  0XFF
#define CMD_ID_POWER_TRACKING  0XFF
#define CMD_ID_PSD  0XFF
#define CMD_ID_P2PPS  0XFF
#define CMD_ID_BT_COEX  0XFF
#define CMD_ID_NAN_CTRL  0XFF
#define CMD_ID_NAN_CHANNEL_PLAN_0  0XFF
#define CMD_ID_NAN_CHANNEL_PLAN_1  0XFF
#define CMD_ID_FW_ACCESS_TEST  0XFF
#define CMD_ID_PHYDM_INFO  0XFF
#define CMD_ID_FW_SNDING  0XFF
#define CMD_ID_H2C_LOOPBACK  0XFF
#define CMD_ID_FWCMD_LOOPBACK  0XFF
#define CATEGORY_H2C_CMD_HEADER  0X00
#define CATEGORY_FW_OFFLOAD_H2C  0X01
#define CATEGORY_CHANNEL_SWITCH  0X01
#define CATEGORY_DUMP_PHYSICAL_EFUSE  0X01
#define CATEGORY_UPDATE_BEACON_PARSING_INFO  0X01
#define CATEGORY_CFG_PARAMETER  0X01
#define CATEGORY_UPDATE_DATAPACK  0X01
#define CATEGORY_RUN_DATAPACK  0X01
#define CATEGORY_DOWNLOAD_FLASH  0X01
#define CATEGORY_UPDATE_PACKET  0X01
#define CATEGORY_GENERAL_INFO  0X01
#define CATEGORY_IQK  0X01
#define CATEGORY_POWER_TRACKING  0X01
#define CATEGORY_PSD  0X01
#define CATEGORY_P2PPS  0X01
#define CATEGORY_BT_COEX  0X01
#define CATEGORY_NAN_CTRL  0X01
#define CATEGORY_NAN_CHANNEL_PLAN_0  0X01
#define CATEGORY_NAN_CHANNEL_PLAN_1  0X01
#define CATEGORY_FW_ACCESS_TEST  0X01
#define CATEGORY_PHYDM_INFO  0X01
#define CATEGORY_FW_SNDING  0X01
#define CATEGORY_H2C_LOOPBACK  0X01
#define CATEGORY_FWCMD_LOOPBACK  0X01
#define SUB_CMD_ID_CHANNEL_SWITCH  0X02
#define SUB_CMD_ID_DUMP_PHYSICAL_EFUSE  0X03
#define SUB_CMD_ID_UPDATE_BEACON_PARSING_INFO  0X05
#define SUB_CMD_ID_CFG_PARAMETER  0X08
#define SUB_CMD_ID_UPDATE_DATAPACK  0X09
#define SUB_CMD_ID_RUN_DATAPACK  0X0A
#define SUB_CMD_ID_DOWNLOAD_FLASH  0X0B
#define SUB_CMD_ID_UPDATE_PACKET  0X0C
#define SUB_CMD_ID_GENERAL_INFO  0X0D
#define SUB_CMD_ID_IQK  0X0E
#define SUB_CMD_ID_POWER_TRACKING  0X0F
#define SUB_CMD_ID_PSD  0X10
#define SUB_CMD_ID_P2PPS  0X24
#define SUB_CMD_ID_BT_COEX  0X60
#define SUB_CMD_ID_NAN_CTRL  0XB2
#define SUB_CMD_ID_NAN_CHANNEL_PLAN_0  0XB4
#define SUB_CMD_ID_NAN_CHANNEL_PLAN_1  0XB5
#define SUB_CMD_ID_FW_ACCESS_TEST  0X00
#define SUB_CMD_ID_PHYDM_INFO  0X11
#define SUB_CMD_ID_FW_SNDING  0X12
#define SUB_CMD_ID_H2C_LOOPBACK  0X14
#define SUB_CMD_ID_FWCMD_LOOPBACK  0X15
#define H2C_CMD_HEADER_GET_CATEGORY(__pH2C)    GET_H2C_FIELD(__pH2C + 0X00, 0, 7)
#define H2C_CMD_HEADER_SET_CATEGORY(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X00, 0, 7, __Value)
#define H2C_CMD_HEADER_SET_CATEGORY_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X00, 0, 7, __Value)
#define H2C_CMD_HEADER_GET_ACK(__pH2C)    GET_H2C_FIELD(__pH2C + 0X00, 7, 1)
#define H2C_CMD_HEADER_SET_ACK(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X00, 7, 1, __Value)
#define H2C_CMD_HEADER_SET_ACK_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X00, 7, 1, __Value)
#define H2C_CMD_HEADER_GET_TOTAL_LEN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X04, 0, 16)
#define H2C_CMD_HEADER_SET_TOTAL_LEN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X04, 0, 16, __Value)
#define H2C_CMD_HEADER_SET_TOTAL_LEN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X04, 0, 16, __Value)
#define H2C_CMD_HEADER_GET_SEQ_NUM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X04, 16, 16)
#define H2C_CMD_HEADER_SET_SEQ_NUM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X04, 16, 16, __Value)
#define H2C_CMD_HEADER_SET_SEQ_NUM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X04, 16, 16, __Value)
#define FW_OFFLOAD_H2C_GET_CATEGORY(__pH2C)    GET_H2C_FIELD(__pH2C + 0X00, 0, 7)
#define FW_OFFLOAD_H2C_SET_CATEGORY(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X00, 0, 7, __Value)
#define FW_OFFLOAD_H2C_SET_CATEGORY_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X00, 0, 7, __Value)
#define FW_OFFLOAD_H2C_GET_ACK(__pH2C)    GET_H2C_FIELD(__pH2C + 0X00, 7, 1)
#define FW_OFFLOAD_H2C_SET_ACK(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X00, 7, 1, __Value)
#define FW_OFFLOAD_H2C_SET_ACK_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X00, 7, 1, __Value)
#define FW_OFFLOAD_H2C_GET_CMD_ID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X00, 8, 8)
#define FW_OFFLOAD_H2C_SET_CMD_ID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X00, 8, 8, __Value)
#define FW_OFFLOAD_H2C_SET_CMD_ID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X00, 8, 8, __Value)
#define FW_OFFLOAD_H2C_GET_SUB_CMD_ID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X00, 16, 16)
#define FW_OFFLOAD_H2C_SET_SUB_CMD_ID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X00, 16, 16, __Value)
#define FW_OFFLOAD_H2C_SET_SUB_CMD_ID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X00, 16, 16, __Value)
#define FW_OFFLOAD_H2C_GET_TOTAL_LEN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X04, 0, 16)
#define FW_OFFLOAD_H2C_SET_TOTAL_LEN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X04, 0, 16, __Value)
#define FW_OFFLOAD_H2C_SET_TOTAL_LEN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X04, 0, 16, __Value)
#define FW_OFFLOAD_H2C_GET_SEQ_NUM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X04, 16, 16)
#define FW_OFFLOAD_H2C_SET_SEQ_NUM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X04, 16, 16, __Value)
#define FW_OFFLOAD_H2C_SET_SEQ_NUM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X04, 16, 16, __Value)
#define CHANNEL_SWITCH_GET_SWITCH_START(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define CHANNEL_SWITCH_SET_SWITCH_START(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define CHANNEL_SWITCH_SET_SWITCH_START_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define CHANNEL_SWITCH_GET_DEST_CH_EN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 1, 1)
#define CHANNEL_SWITCH_SET_DEST_CH_EN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 1, 1, __Value)
#define CHANNEL_SWITCH_SET_DEST_CH_EN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 1, 1, __Value)
#define CHANNEL_SWITCH_GET_ABSOLUTE_TIME(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 2, 1)
#define CHANNEL_SWITCH_SET_ABSOLUTE_TIME(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 2, 1, __Value)
#define CHANNEL_SWITCH_SET_ABSOLUTE_TIME_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 2, 1, __Value)
#define CHANNEL_SWITCH_GET_PERIODIC_OPTION(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 3, 2)
#define CHANNEL_SWITCH_SET_PERIODIC_OPTION(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 3, 2, __Value)
#define CHANNEL_SWITCH_SET_PERIODIC_OPTION_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 3, 2, __Value)
#define CHANNEL_SWITCH_GET_CHANNEL_INFO_LOC(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define CHANNEL_SWITCH_SET_CHANNEL_INFO_LOC(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define CHANNEL_SWITCH_SET_CHANNEL_INFO_LOC_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define CHANNEL_SWITCH_GET_CHANNEL_NUM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define CHANNEL_SWITCH_SET_CHANNEL_NUM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define CHANNEL_SWITCH_SET_CHANNEL_NUM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define CHANNEL_SWITCH_GET_PRI_CH_IDX(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 4)
#define CHANNEL_SWITCH_SET_PRI_CH_IDX(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 4, __Value)
#define CHANNEL_SWITCH_SET_PRI_CH_IDX_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 4, __Value)
#define CHANNEL_SWITCH_GET_DEST_BW(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 28, 4)
#define CHANNEL_SWITCH_SET_DEST_BW(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 28, 4, __Value)
#define CHANNEL_SWITCH_SET_DEST_BW_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 28, 4, __Value)
#define CHANNEL_SWITCH_GET_DEST_CH(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 8)
#define CHANNEL_SWITCH_SET_DEST_CH(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define CHANNEL_SWITCH_SET_DEST_CH_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define CHANNEL_SWITCH_GET_NORMAL_PERIOD(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 8, 6)
#define CHANNEL_SWITCH_SET_NORMAL_PERIOD(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 8, 6, __Value)
#define CHANNEL_SWITCH_SET_NORMAL_PERIOD_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 8, 6, __Value)
#define CHANNEL_SWITCH_GET_NORMAL_PERIOD_SEL(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 14, 2)
#define CHANNEL_SWITCH_SET_NORMAL_PERIOD_SEL(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 14, 2, __Value)
#define CHANNEL_SWITCH_SET_NORMAL_PERIOD_SEL_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 14, 2, __Value)
#define CHANNEL_SWITCH_GET_SLOW_PERIOD(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 16, 6)
#define CHANNEL_SWITCH_SET_SLOW_PERIOD(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 16, 6, __Value)
#define CHANNEL_SWITCH_SET_SLOW_PERIOD_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 16, 6, __Value)
#define CHANNEL_SWITCH_GET_SLOW_PERIOD_SEL(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 22, 2)
#define CHANNEL_SWITCH_SET_SLOW_PERIOD_SEL(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 22, 2, __Value)
#define CHANNEL_SWITCH_SET_SLOW_PERIOD_SEL_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 22, 2, __Value)
#define CHANNEL_SWITCH_GET_NORMAL_CYCLE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 24, 8)
#define CHANNEL_SWITCH_SET_NORMAL_CYCLE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 24, 8, __Value)
#define CHANNEL_SWITCH_SET_NORMAL_CYCLE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 24, 8, __Value)
#define CHANNEL_SWITCH_GET_TSF_HIGH(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 32)
#define CHANNEL_SWITCH_SET_TSF_HIGH(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 32, __Value)
#define CHANNEL_SWITCH_SET_TSF_HIGH_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 32, __Value)
#define CHANNEL_SWITCH_GET_TSF_LOW(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 0, 32)
#define CHANNEL_SWITCH_SET_TSF_LOW(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 0, 32, __Value)
#define CHANNEL_SWITCH_SET_TSF_LOW_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 0, 32, __Value)
#define CHANNEL_SWITCH_GET_CHANNEL_INFO_SIZE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 0, 16)
#define CHANNEL_SWITCH_SET_CHANNEL_INFO_SIZE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 0, 16, __Value)
#define CHANNEL_SWITCH_SET_CHANNEL_INFO_SIZE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 0, 16, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_FUNC_EN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define UPDATE_BEACON_PARSING_INFO_SET_FUNC_EN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_FUNC_EN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_SIZE_TH(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 4)
#define UPDATE_BEACON_PARSING_INFO_SET_SIZE_TH(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 4, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_SIZE_TH_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 4, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_TIMEOUT(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 12, 4)
#define UPDATE_BEACON_PARSING_INFO_SET_TIMEOUT(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 12, 4, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_TIMEOUT_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 12, 4, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_IE_ID_BMP_0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 32)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_IE_ID_BMP_1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 32)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_IE_ID_BMP_2(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 0, 32)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_2(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_2_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_IE_ID_BMP_3(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 0, 32)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_3(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_3_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_GET_IE_ID_BMP_4(__pH2C)    GET_H2C_FIELD(__pH2C + 0X1C, 0, 32)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_4(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X1C, 0, 32, __Value)
#define UPDATE_BEACON_PARSING_INFO_SET_IE_ID_BMP_4_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X1C, 0, 32, __Value)
#define CFG_PARAMETER_GET_NUM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 16)
#define CFG_PARAMETER_SET_NUM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 16, __Value)
#define CFG_PARAMETER_SET_NUM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 16, __Value)
#define CFG_PARAMETER_GET_INIT_CASE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 1)
#define CFG_PARAMETER_SET_INIT_CASE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 1, __Value)
#define CFG_PARAMETER_SET_INIT_CASE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 1, __Value)
#define CFG_PARAMETER_GET_PHY_PARAMETER_LOC(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 8)
#define CFG_PARAMETER_SET_PHY_PARAMETER_LOC(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 8, __Value)
#define CFG_PARAMETER_SET_PHY_PARAMETER_LOC_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 8, __Value)
#define UPDATE_DATAPACK_GET_SIZE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 16)
#define UPDATE_DATAPACK_SET_SIZE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 16, __Value)
#define UPDATE_DATAPACK_SET_SIZE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 16, __Value)
#define UPDATE_DATAPACK_GET_DATAPACK_ID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define UPDATE_DATAPACK_SET_DATAPACK_ID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define UPDATE_DATAPACK_SET_DATAPACK_ID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define UPDATE_DATAPACK_GET_DATAPACK_LOC(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 8)
#define UPDATE_DATAPACK_SET_DATAPACK_LOC(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 8, __Value)
#define UPDATE_DATAPACK_SET_DATAPACK_LOC_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 8, __Value)
#define UPDATE_DATAPACK_GET_DATAPACK_SEGMENT(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 8)
#define UPDATE_DATAPACK_SET_DATAPACK_SEGMENT(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define UPDATE_DATAPACK_SET_DATAPACK_SEGMENT_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define UPDATE_DATAPACK_GET_END_SEGMENT(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 8, 1)
#define UPDATE_DATAPACK_SET_END_SEGMENT(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 8, 1, __Value)
#define UPDATE_DATAPACK_SET_END_SEGMENT_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 8, 1, __Value)
#define RUN_DATAPACK_GET_DATAPACK_ID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 8)
#define RUN_DATAPACK_SET_DATAPACK_ID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 8, __Value)
#define RUN_DATAPACK_SET_DATAPACK_ID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 8, __Value)
#define DOWNLOAD_FLASH_GET_SPI_CMD(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 8)
#define DOWNLOAD_FLASH_SET_SPI_CMD(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 8, __Value)
#define DOWNLOAD_FLASH_SET_SPI_CMD_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 8, __Value)
#define DOWNLOAD_FLASH_GET_LOCATION(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 16)
#define DOWNLOAD_FLASH_SET_LOCATION(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 16, __Value)
#define DOWNLOAD_FLASH_SET_LOCATION_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 16, __Value)
#define DOWNLOAD_FLASH_GET_SIZE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 32)
#define DOWNLOAD_FLASH_SET_SIZE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 32, __Value)
#define DOWNLOAD_FLASH_SET_SIZE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 32, __Value)
#define DOWNLOAD_FLASH_GET_START_ADDR(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 32)
#define DOWNLOAD_FLASH_SET_START_ADDR(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 32, __Value)
#define DOWNLOAD_FLASH_SET_START_ADDR_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 32, __Value)
#define UPDATE_PACKET_GET_SIZE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 16)
#define UPDATE_PACKET_SET_SIZE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 16, __Value)
#define UPDATE_PACKET_SET_SIZE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 16, __Value)
#define UPDATE_PACKET_GET_PACKET_ID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define UPDATE_PACKET_SET_PACKET_ID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define UPDATE_PACKET_SET_PACKET_ID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define UPDATE_PACKET_GET_PACKET_LOC(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 8)
#define UPDATE_PACKET_SET_PACKET_LOC(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 8, __Value)
#define UPDATE_PACKET_SET_PACKET_LOC_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 8, __Value)
#define GENERAL_INFO_GET_FW_TX_BOUNDARY(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define GENERAL_INFO_SET_FW_TX_BOUNDARY(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define GENERAL_INFO_SET_FW_TX_BOUNDARY_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define IQK_GET_CLEAR(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define IQK_SET_CLEAR(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define IQK_SET_CLEAR_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define IQK_GET_SEGMENT_IQK(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 1, 1)
#define IQK_SET_SEGMENT_IQK(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 1, 1, __Value)
#define IQK_SET_SEGMENT_IQK_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 1, 1, __Value)
#define POWER_TRACKING_GET_ENABLE_A(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define POWER_TRACKING_SET_ENABLE_A(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define POWER_TRACKING_SET_ENABLE_A_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define POWER_TRACKING_GET_ENABLE_B(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 1, 1)
#define POWER_TRACKING_SET_ENABLE_B(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 1, 1, __Value)
#define POWER_TRACKING_SET_ENABLE_B_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 1, 1, __Value)
#define POWER_TRACKING_GET_ENABLE_C(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 2, 1)
#define POWER_TRACKING_SET_ENABLE_C(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 2, 1, __Value)
#define POWER_TRACKING_SET_ENABLE_C_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 2, 1, __Value)
#define POWER_TRACKING_GET_ENABLE_D(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 3, 1)
#define POWER_TRACKING_SET_ENABLE_D(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 3, 1, __Value)
#define POWER_TRACKING_SET_ENABLE_D_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 3, 1, __Value)
#define POWER_TRACKING_GET_TYPE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 4, 3)
#define POWER_TRACKING_SET_TYPE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 4, 3, __Value)
#define POWER_TRACKING_SET_TYPE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 4, 3, __Value)
#define POWER_TRACKING_GET_BBSWING_INDEX(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define POWER_TRACKING_SET_BBSWING_INDEX(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define POWER_TRACKING_SET_BBSWING_INDEX_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define POWER_TRACKING_GET_TX_PWR_INDEX_A(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 8)
#define POWER_TRACKING_SET_TX_PWR_INDEX_A(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define POWER_TRACKING_SET_TX_PWR_INDEX_A_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define POWER_TRACKING_GET_PWR_TRACKING_OFFSET_VALUE_A(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 8, 8)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_A(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 8, 8, __Value)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_A_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 8, 8, __Value)
#define POWER_TRACKING_GET_TSSI_VALUE_A(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 16, 8)
#define POWER_TRACKING_SET_TSSI_VALUE_A(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 16, 8, __Value)
#define POWER_TRACKING_SET_TSSI_VALUE_A_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 16, 8, __Value)
#define POWER_TRACKING_GET_TX_PWR_INDEX_B(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 8)
#define POWER_TRACKING_SET_TX_PWR_INDEX_B(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 8, __Value)
#define POWER_TRACKING_SET_TX_PWR_INDEX_B_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 8, __Value)
#define POWER_TRACKING_GET_PWR_TRACKING_OFFSET_VALUE_B(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 8, 8)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_B(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 8, 8, __Value)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_B_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 8, 8, __Value)
#define POWER_TRACKING_GET_TSSI_VALUE_B(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 16, 8)
#define POWER_TRACKING_SET_TSSI_VALUE_B(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 16, 8, __Value)
#define POWER_TRACKING_SET_TSSI_VALUE_B_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 16, 8, __Value)
#define POWER_TRACKING_GET_TX_PWR_INDEX_C(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 0, 8)
#define POWER_TRACKING_SET_TX_PWR_INDEX_C(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 0, 8, __Value)
#define POWER_TRACKING_SET_TX_PWR_INDEX_C_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 0, 8, __Value)
#define POWER_TRACKING_GET_PWR_TRACKING_OFFSET_VALUE_C(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 8, 8)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_C(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 8, 8, __Value)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_C_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 8, 8, __Value)
#define POWER_TRACKING_GET_TSSI_VALUE_C(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 16, 8)
#define POWER_TRACKING_SET_TSSI_VALUE_C(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 16, 8, __Value)
#define POWER_TRACKING_SET_TSSI_VALUE_C_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 16, 8, __Value)
#define POWER_TRACKING_GET_TX_PWR_INDEX_D(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 0, 8)
#define POWER_TRACKING_SET_TX_PWR_INDEX_D(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 0, 8, __Value)
#define POWER_TRACKING_SET_TX_PWR_INDEX_D_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 0, 8, __Value)
#define POWER_TRACKING_GET_PWR_TRACKING_OFFSET_VALUE_D(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 8, 8)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_D(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 8, 8, __Value)
#define POWER_TRACKING_SET_PWR_TRACKING_OFFSET_VALUE_D_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 8, 8, __Value)
#define POWER_TRACKING_GET_TSSI_VALUE_D(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 16, 8)
#define POWER_TRACKING_SET_TSSI_VALUE_D(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 16, 8, __Value)
#define POWER_TRACKING_SET_TSSI_VALUE_D_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 16, 8, __Value)
#define PSD_GET_START_PSD(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 16)
#define PSD_SET_START_PSD(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 16, __Value)
#define PSD_SET_START_PSD_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 16, __Value)
#define PSD_GET_END_PSD(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 16)
#define PSD_SET_END_PSD(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 16, __Value)
#define PSD_SET_END_PSD_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 16, __Value)
#define P2PPS_GET_OFFLOAD_EN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define P2PPS_SET_OFFLOAD_EN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define P2PPS_SET_OFFLOAD_EN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define P2PPS_GET_ROLE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 1, 1)
#define P2PPS_SET_ROLE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 1, 1, __Value)
#define P2PPS_SET_ROLE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 1, 1, __Value)
#define P2PPS_GET_CTWINDOW_EN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 2, 1)
#define P2PPS_SET_CTWINDOW_EN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 2, 1, __Value)
#define P2PPS_SET_CTWINDOW_EN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 2, 1, __Value)
#define P2PPS_GET_NOA_EN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 3, 1)
#define P2PPS_SET_NOA_EN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 3, 1, __Value)
#define P2PPS_SET_NOA_EN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 3, 1, __Value)
#define P2PPS_GET_NOA_SEL(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 4, 1)
#define P2PPS_SET_NOA_SEL(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 4, 1, __Value)
#define P2PPS_SET_NOA_SEL_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 4, 1, __Value)
#define P2PPS_GET_ALLSTASLEEP(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 5, 1)
#define P2PPS_SET_ALLSTASLEEP(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 5, 1, __Value)
#define P2PPS_SET_ALLSTASLEEP_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 5, 1, __Value)
#define P2PPS_GET_DISCOVERY(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 6, 1)
#define P2PPS_SET_DISCOVERY(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 6, 1, __Value)
#define P2PPS_SET_DISCOVERY_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 6, 1, __Value)
#define P2PPS_GET_DISABLE_CLOSERF(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 7, 1)
#define P2PPS_SET_DISABLE_CLOSERF(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 7, 1, __Value)
#define P2PPS_SET_DISABLE_CLOSERF_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 7, 1, __Value)
#define P2PPS_GET_P2P_PORT_ID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define P2PPS_SET_P2P_PORT_ID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define P2PPS_SET_P2P_PORT_ID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define P2PPS_GET_P2P_GROUP(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define P2PPS_SET_P2P_GROUP(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define P2PPS_SET_P2P_GROUP_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define P2PPS_GET_P2P_MACID(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 8)
#define P2PPS_SET_P2P_MACID(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 8, __Value)
#define P2PPS_SET_P2P_MACID_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 8, __Value)
#define P2PPS_GET_CTWINDOW_LENGTH(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 8)
#define P2PPS_SET_CTWINDOW_LENGTH(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define P2PPS_SET_CTWINDOW_LENGTH_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define P2PPS_GET_NOA_DURATION_PARA(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 32)
#define P2PPS_SET_NOA_DURATION_PARA(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 32, __Value)
#define P2PPS_SET_NOA_DURATION_PARA_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 32, __Value)
#define P2PPS_GET_NOA_INTERVAL_PARA(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 0, 32)
#define P2PPS_SET_NOA_INTERVAL_PARA(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 0, 32, __Value)
#define P2PPS_SET_NOA_INTERVAL_PARA_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 0, 32, __Value)
#define P2PPS_GET_NOA_START_TIME_PARA(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 0, 32)
#define P2PPS_SET_NOA_START_TIME_PARA(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 0, 32, __Value)
#define P2PPS_SET_NOA_START_TIME_PARA_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 0, 32, __Value)
#define P2PPS_GET_NOA_COUNT_PARA(__pH2C)    GET_H2C_FIELD(__pH2C + 0X1C, 0, 32)
#define P2PPS_SET_NOA_COUNT_PARA(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X1C, 0, 32, __Value)
#define P2PPS_SET_NOA_COUNT_PARA_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X1C, 0, 32, __Value)
#define BT_COEX_GET_DATA_START(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 8)
#define BT_COEX_SET_DATA_START(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 8, __Value)
#define BT_COEX_SET_DATA_START_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 8, __Value)
#define NAN_CTRL_GET_NAN_EN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 2)
#define NAN_CTRL_SET_NAN_EN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 2, __Value)
#define NAN_CTRL_SET_NAN_EN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 2, __Value)
#define NAN_CTRL_GET_WARMUP_TIMER_FLAG(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 2, 1)
#define NAN_CTRL_SET_WARMUP_TIMER_FLAG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 2, 1, __Value)
#define NAN_CTRL_SET_WARMUP_TIMER_FLAG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 2, 1, __Value)
#define NAN_CTRL_GET_SUPPORT_BAND(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 2)
#define NAN_CTRL_SET_SUPPORT_BAND(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 2, __Value)
#define NAN_CTRL_SET_SUPPORT_BAND_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 2, __Value)
#define NAN_CTRL_GET_DISABLE_2G_DISC_BCN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 10, 1)
#define NAN_CTRL_SET_DISABLE_2G_DISC_BCN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 10, 1, __Value)
#define NAN_CTRL_SET_DISABLE_2G_DISC_BCN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 10, 1, __Value)
#define NAN_CTRL_GET_DISABLE_5G_DISC_BCN(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 11, 1)
#define NAN_CTRL_SET_DISABLE_5G_DISC_BCN(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 11, 1, __Value)
#define NAN_CTRL_SET_DISABLE_5G_DISC_BCN_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 11, 1, __Value)
#define NAN_CTRL_GET_BCN_RSVD_PAGE_OFFSET(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define NAN_CTRL_SET_BCN_RSVD_PAGE_OFFSET(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define NAN_CTRL_SET_BCN_RSVD_PAGE_OFFSET_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define NAN_CTRL_GET_CHANNEL_2G(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 8)
#define NAN_CTRL_SET_CHANNEL_2G(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 8, __Value)
#define NAN_CTRL_SET_CHANNEL_2G_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 8, __Value)
#define NAN_CTRL_GET_CHANNEL_5G(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 8)
#define NAN_CTRL_SET_CHANNEL_5G(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define NAN_CTRL_SET_CHANNEL_5G_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 8, __Value)
#define NAN_CTRL_GET_MASTERPREFERENCE_VALUE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 8, 8)
#define NAN_CTRL_SET_MASTERPREFERENCE_VALUE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 8, 8, __Value)
#define NAN_CTRL_SET_MASTERPREFERENCE_VALUE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 8, 8, __Value)
#define NAN_CTRL_GET_RANDOMFACTOR_VALUE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 16, 8)
#define NAN_CTRL_SET_RANDOMFACTOR_VALUE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 16, 8, __Value)
#define NAN_CTRL_SET_RANDOMFACTOR_VALUE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 16, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_CHANNEL_NUMBER_0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 8)
#define NAN_CHANNEL_PLAN_0_SET_CHANNEL_NUMBER_0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_0_SET_CHANNEL_NUMBER_0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_UNPAUSE_MACID_0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define NAN_CHANNEL_PLAN_0_SET_UNPAUSE_MACID_0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_0_SET_UNPAUSE_MACID_0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_START_TIME_SLOT_0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 16)
#define NAN_CHANNEL_PLAN_0_SET_START_TIME_SLOT_0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_0_SET_START_TIME_SLOT_0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_0_GET_DURATION_0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 16, 16)
#define NAN_CHANNEL_PLAN_0_SET_DURATION_0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_0_SET_DURATION_0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_0_GET_CHANNEL_NUMBER_1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 8)
#define NAN_CHANNEL_PLAN_0_SET_CHANNEL_NUMBER_1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_0_SET_CHANNEL_NUMBER_1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_UNPAUSE_MACID_1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 8, 8)
#define NAN_CHANNEL_PLAN_0_SET_UNPAUSE_MACID_1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_0_SET_UNPAUSE_MACID_1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_START_TIME_SLOT_1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 0, 16)
#define NAN_CHANNEL_PLAN_0_SET_START_TIME_SLOT_1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_0_SET_START_TIME_SLOT_1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_0_GET_DURATION_1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 16, 16)
#define NAN_CHANNEL_PLAN_0_SET_DURATION_1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_0_SET_DURATION_1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_0_GET_CHANNEL_NUMBER_2(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 0, 8)
#define NAN_CHANNEL_PLAN_0_SET_CHANNEL_NUMBER_2(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_0_SET_CHANNEL_NUMBER_2_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_UNPAUSE_MACID_2(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 8, 8)
#define NAN_CHANNEL_PLAN_0_SET_UNPAUSE_MACID_2(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_0_SET_UNPAUSE_MACID_2_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_0_GET_START_TIME_SLOT_2(__pH2C)    GET_H2C_FIELD(__pH2C + 0X1C, 0, 16)
#define NAN_CHANNEL_PLAN_0_SET_START_TIME_SLOT_2(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X1C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_0_SET_START_TIME_SLOT_2_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X1C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_0_GET_DURATION_2(__pH2C)    GET_H2C_FIELD(__pH2C + 0X1C, 16, 16)
#define NAN_CHANNEL_PLAN_0_SET_DURATION_2(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X1C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_0_SET_DURATION_2_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X1C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_1_GET_CHANNEL_NUMBER_3(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 8)
#define NAN_CHANNEL_PLAN_1_SET_CHANNEL_NUMBER_3(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_1_SET_CHANNEL_NUMBER_3_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_1_GET_UNPAUSE_MACID_3(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define NAN_CHANNEL_PLAN_1_SET_UNPAUSE_MACID_3(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_1_SET_UNPAUSE_MACID_3_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_1_GET_START_TIME_SLOT_3(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 0, 16)
#define NAN_CHANNEL_PLAN_1_SET_START_TIME_SLOT_3(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_1_SET_START_TIME_SLOT_3_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_1_GET_DURATION_3(__pH2C)    GET_H2C_FIELD(__pH2C + 0X0C, 16, 16)
#define NAN_CHANNEL_PLAN_1_SET_DURATION_3(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X0C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_1_SET_DURATION_3_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X0C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_1_GET_CHANNEL_NUMBER_4(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 0, 8)
#define NAN_CHANNEL_PLAN_1_SET_CHANNEL_NUMBER_4(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_1_SET_CHANNEL_NUMBER_4_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_1_GET_UNPAUSE_MACID_4(__pH2C)    GET_H2C_FIELD(__pH2C + 0X10, 8, 8)
#define NAN_CHANNEL_PLAN_1_SET_UNPAUSE_MACID_4(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X10, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_1_SET_UNPAUSE_MACID_4_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X10, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_1_GET_START_TIME_SLOT_4(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 0, 16)
#define NAN_CHANNEL_PLAN_1_SET_START_TIME_SLOT_4(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_1_SET_START_TIME_SLOT_4_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_1_GET_DURATION_4(__pH2C)    GET_H2C_FIELD(__pH2C + 0X14, 16, 16)
#define NAN_CHANNEL_PLAN_1_SET_DURATION_4(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X14, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_1_SET_DURATION_4_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X14, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_1_GET_CHANNEL_NUMBER_5(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 0, 8)
#define NAN_CHANNEL_PLAN_1_SET_CHANNEL_NUMBER_5(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_1_SET_CHANNEL_NUMBER_5_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 0, 8, __Value)
#define NAN_CHANNEL_PLAN_1_GET_UNPAUSE_MACID_5(__pH2C)    GET_H2C_FIELD(__pH2C + 0X18, 8, 8)
#define NAN_CHANNEL_PLAN_1_SET_UNPAUSE_MACID_5(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X18, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_1_SET_UNPAUSE_MACID_5_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X18, 8, 8, __Value)
#define NAN_CHANNEL_PLAN_1_GET_START_TIME_SLOT_5(__pH2C)    GET_H2C_FIELD(__pH2C + 0X1C, 0, 16)
#define NAN_CHANNEL_PLAN_1_SET_START_TIME_SLOT_5(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X1C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_1_SET_START_TIME_SLOT_5_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X1C, 0, 16, __Value)
#define NAN_CHANNEL_PLAN_1_GET_DURATION_5(__pH2C)    GET_H2C_FIELD(__pH2C + 0X1C, 16, 16)
#define NAN_CHANNEL_PLAN_1_SET_DURATION_5(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X1C, 16, 16, __Value)
#define NAN_CHANNEL_PLAN_1_SET_DURATION_5_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X1C, 16, 16, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_TXFF(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define FW_ACCESS_TEST_SET_ACCESS_TXFF(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_TXFF_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_RXFF(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 1, 1)
#define FW_ACCESS_TEST_SET_ACCESS_RXFF(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 1, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_RXFF_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 1, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_FWFF(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 2, 1)
#define FW_ACCESS_TEST_SET_ACCESS_FWFF(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 2, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_FWFF_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 2, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PHYFF(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 3, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PHYFF(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 3, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PHYFF_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 3, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_RPT_BUF(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 4, 1)
#define FW_ACCESS_TEST_SET_ACCESS_RPT_BUF(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 4, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_RPT_BUF_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 4, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_CAM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 5, 1)
#define FW_ACCESS_TEST_SET_ACCESS_CAM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 5, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_CAM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 5, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_WOW_CAM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 6, 1)
#define FW_ACCESS_TEST_SET_ACCESS_WOW_CAM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 6, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_WOW_CAM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 6, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_RX_CAM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 7, 1)
#define FW_ACCESS_TEST_SET_ACCESS_RX_CAM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 7, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_RX_CAM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 7, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_BA_CAM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 1)
#define FW_ACCESS_TEST_SET_ACCESS_BA_CAM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_BA_CAM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_MBSSID_CAM(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 9, 1)
#define FW_ACCESS_TEST_SET_ACCESS_MBSSID_CAM(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 9, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_MBSSID_CAM_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 9, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 17, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 17, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 17, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE2(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 18, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE2(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 18, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE2_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 18, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE3(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 19, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE3(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 19, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE3_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 19, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE4(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 20, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE4(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 20, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE4_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 20, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE5(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 21, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE5(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 21, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE5_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 21, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE6(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 22, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE6(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 22, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE6_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 22, 1, __Value)
#define FW_ACCESS_TEST_GET_ACCESS_PAGE7(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 23, 1)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE7(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 23, 1, __Value)
#define FW_ACCESS_TEST_SET_ACCESS_PAGE7_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 23, 1, __Value)
#define PHYDM_INFO_GET_REF_TYPE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 8)
#define PHYDM_INFO_SET_REF_TYPE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 8, __Value)
#define PHYDM_INFO_SET_REF_TYPE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 8, __Value)
#define PHYDM_INFO_GET_RF_TYPE(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define PHYDM_INFO_SET_RF_TYPE(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define PHYDM_INFO_SET_RF_TYPE_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define PHYDM_INFO_GET_CUT_VER(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define PHYDM_INFO_SET_CUT_VER(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define PHYDM_INFO_SET_CUT_VER_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define PHYDM_INFO_GET_RX_ANT_STATUS(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 4)
#define PHYDM_INFO_SET_RX_ANT_STATUS(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 4, __Value)
#define PHYDM_INFO_SET_RX_ANT_STATUS_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 4, __Value)
#define PHYDM_INFO_GET_TX_ANT_STATUS(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 28, 4)
#define PHYDM_INFO_SET_TX_ANT_STATUS(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 28, 4, __Value)
#define PHYDM_INFO_SET_TX_ANT_STATUS_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 28, 4, __Value)
#define FW_SNDING_GET_SU0(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 0, 1)
#define FW_SNDING_SET_SU0(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 0, 1, __Value)
#define FW_SNDING_SET_SU0_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 0, 1, __Value)
#define FW_SNDING_GET_SU1(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 1, 1)
#define FW_SNDING_SET_SU1(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 1, 1, __Value)
#define FW_SNDING_SET_SU1_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 1, 1, __Value)
#define FW_SNDING_GET_MU(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 2, 1)
#define FW_SNDING_SET_MU(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 2, 1, __Value)
#define FW_SNDING_SET_MU_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 2, 1, __Value)
#define FW_SNDING_GET_PERIOD(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 8, 8)
#define FW_SNDING_SET_PERIOD(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 8, 8, __Value)
#define FW_SNDING_SET_PERIOD_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 8, 8, __Value)
#define FW_SNDING_GET_NDPA0_HEAD_PG(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 16, 8)
#define FW_SNDING_SET_NDPA0_HEAD_PG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 16, 8, __Value)
#define FW_SNDING_SET_NDPA0_HEAD_PG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 16, 8, __Value)
#define FW_SNDING_GET_NDPA1_HEAD_PG(__pH2C)    GET_H2C_FIELD(__pH2C + 0X08, 24, 8)
#define FW_SNDING_SET_NDPA1_HEAD_PG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0X08, 24, 8, __Value)
#define FW_SNDING_SET_NDPA1_HEAD_PG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0X08, 24, 8, __Value)
#define FW_SNDING_GET_MU_NDPA_HEAD_PG(__pH2C)    GET_H2C_FIELD(__pH2C + 0XC, 0, 8)
#define FW_SNDING_SET_MU_NDPA_HEAD_PG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0XC, 0, 8, __Value)
#define FW_SNDING_SET_MU_NDPA_HEAD_PG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0XC, 0, 8, __Value)
#define FW_SNDING_GET_RPT0_HEAD_PG(__pH2C)    GET_H2C_FIELD(__pH2C + 0XC, 8, 8)
#define FW_SNDING_SET_RPT0_HEAD_PG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0XC, 8, 8, __Value)
#define FW_SNDING_SET_RPT0_HEAD_PG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0XC, 8, 8, __Value)
#define FW_SNDING_GET_RPT1_HEAD_PG(__pH2C)    GET_H2C_FIELD(__pH2C + 0XC, 16, 8)
#define FW_SNDING_SET_RPT1_HEAD_PG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0XC, 16, 8, __Value)
#define FW_SNDING_SET_RPT1_HEAD_PG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0XC, 16, 8, __Value)
#define FW_SNDING_GET_RPT2_HEAD_PG(__pH2C)    GET_H2C_FIELD(__pH2C + 0XC, 24, 8)
#define FW_SNDING_SET_RPT2_HEAD_PG(__pH2C, __Value)    SET_H2C_FIELD_CLR(__pH2C + 0XC, 24, 8, __Value)
#define FW_SNDING_SET_RPT2_HEAD_PG_NO_CLR(__pH2C, __Value)    SET_H2C_FIELD_NO_CLR(__pH2C + 0XC, 24, 8, __Value)
#endif
